#!/usr/bin/perl -T
# $Id: ajax_multi.cgi,v 1.38 2013/06/20 10:24:21 sofc Exp $
use Cwd;
use strict;
use warnings;
use Impedance::Model;
use Impedance::Header;
use Impedance::IMPCGI qw(:DEFAULT :html :cgi);
use CGI qw(:standard :netscape);
use File::stat;
use File::Copy;
use File::Touch;
use SocketClient;
use SemaforeFile;
use Math::Trig;
use Math::Complex qw(cplx Im Re);
use ElchemeaConfig;
unless (param('ajax') && param('action'))
{
    print header();
    print "Oops, no parameters!\n";
    exit;
}
my $ac = param('action');

my @lt = (1,3,4,7,8,2,5,10,12,13,16,17,11,14,19,21,22,25,26,20,23,28,29,30,31);
my @pt = (1,3,4,7,8,2,5,10,12,13,16,17,11,14,19,21,22,25,26,20,23,28,29,30,31);

if ($ac eq 'save')
{
    my $files = param('filenames');
    if ($files)
    {
        $files =~ /([\w\,\.\-\:\+\/\s]+)/;
        $files = $1;
    }
    my $sessionid = get_CGI_value_clean('session');
    my @list = split(/,/,$files);
    unless (@list)
    {
	print header();
	print start_html();
	print center(h1("No files selected!"));
	print end_html();
        exit;
    }
    my $fn = 'Multiplot_'.time.'.emp';
    my $semfile = SemaforeFile->new('/tmp/'.$fn);
    $semfile->writeline('');
    my $file = ElchemeaConfig->new($semfile);
    my $style = param('style');
    $style = 'lines' unless ($style);
    my $mode = param('mode');
    $mode = 'Impedance' unless ($mode);
    my $admode = param('admode');
    $mode = 'Impedance' unless ($admode);
    my $xmin = get_CGI_value_clean('xmin');
    my $xmax = get_CGI_value_clean('xmax');
    my $ymin = get_CGI_value_clean('ymin');
    my $ymax = get_CGI_value_clean('ymax');
    my $color = lc(get_CGI_value_clean('color'));
    $color = 'color' unless $color;
    my $key = lc(get_CGI_value_clean('key'));
    my $scale = lc(get_CGI_value_clean('scale'));
    my $title = lc(get_CGI_value_clean('title'));
    my $comm = param('comm');
    my $labels = get_CGI_value_clean('labels');
    $file->change_config_value('plot','style',$style);
    $file->change_config_value('plot','mode',$mode);
    $file->change_config_value('plot','admode',$admode);
    $file->change_config_value('plot','xmin',$xmin);
    $file->change_config_value('plot','xmax',$xmax);
    $file->change_config_value('plot','ymin',$ymin);
    $file->change_config_value('plot','ymax',$ymax);
    $file->change_config_value('plot','color',$color);
    $file->change_config_value('plot','key',$key);
    $file->change_config_value('plot','labels',$labels);
    $file->change_config_value('plot','scale',$scale);
    $file->change_config_value('plot','title',$title);
    my $x = 0;
    foreach my $line (split(/\n/,$comm))
    {
	$file->change_config_value('Comments',$x++,$line);
    }
    $file->change_config_value('Comments','lines',$x);
    my @filenames = ();
    my $filenr = 0;
    foreach my $item (@list)
    {
	$filenr++;
        my ($fl,$label) = split(/:/,$item);
	next unless $fl;
	my $f = SemaforeFile->new('/tmp/'.$fl);
	$fl =~ s/^$sessionid//;
	$fl =~ s/^_//;
	$fl =~ s/\.data$//;
	$label =~ s/^$sessionid//;
	$label =~ s/^_//;
	$label =~ s/\.data$//;
	my @lines = $f->readlines();
	$x = 0;
	foreach my $line (@lines)
	{
	    $file->change_config_value('File_'.$filenr,$x++,$line);
	}
	$file->change_config_value('File_'.$filenr,'lines',$x);
	$file->change_config_value('File_'.$filenr,'name',$fl);
	$file->change_config_value('File_'.$filenr,'label',$label);
	push @filenames,$fl;
    }
    $file->change_config_value('plot','files',$filenr);
    print "Content-type:application/x-download\n";
    print "Content-Disposition:attachment;filename=$fn\n\n";
    print join("\n",$file->readlines());
    unlink $semfile->filename if ($semfile->exist);
    exit;
}

print header();

if ($ac eq 'load_session')
{
    my $system = param('system');
    my $user = get_CGI_value_clean('user');
    if ($user eq '')
    {
	print "OK\n";
	print ":Session:";
	exit;
    }
    if ($system && $system eq 'Elchemea')
    {
	my @sessions = ();
	my $dir = '/home/elchemea/users/'.$user.'/';
	if (-d $dir)
	{
	    opendir (MYDIR,$dir) or die "Could not open directory $dir $!\n";
	    @sessions = sort {$a <=> $b} grep {/\d+/} readdir MYDIR;
	    closedir MYDIR;
	}
	print "OK\n";
	print ":Session:\n";
	my @list = ();
	foreach (@sessions)
	{
	    push @list,"$_:$_";
	}
	print join("\n",@list);
	exit;
    }
    if ($system && $system eq 'RFCcontrol')
    {
	my @sessions = ();
	my $dir = '/home/http/html/'.$user.'/';
	if (-d $dir)
	{
	    opendir (MYDIR,$dir) or die "Could not open directory $dir $!\n";
	    @sessions = grep {/\d+test\d+/i} readdir MYDIR;
	    closedir MYDIR;
	    my %ses = ();
	    foreach (@sessions)
	    {
		/(\d+)$/;
		$ses{$1} = $_;
	    }
	    @sessions = ();
	    foreach my $key (sort {$a <=> $b} keys %ses)
	    {
		push @sessions,$ses{$key};
	    }
	}
	print "OK\n";
	print ":Test:\n";
	my @list = ();
	foreach (@sessions)
	{
	    push @list,"$_:$_";
	}
	print join("\n",@list);
	exit;
    }
}

sub imp_sort
{
    return ($a <=> $b) unless ($a && $a =~ /s\d+_\d+\w*?\.i2b/ && $b && $b =~ /s\d+_\d+\w*?\.i2b/);
    $a =~ /s\d+_(\d+)\w*?\.i2b/;
    my $left = $1;
    $b =~ /s\d+_(\d+)\w*?\.i2b/;
    my $right = $1;
    return $left <=> $right;
}

if ($ac eq 'set_session')
{
    my $system = param('system');
    my $user = get_CGI_value_clean('user');
    my $session = get_CGI_value_clean('session');
    if ($system && $system eq 'Elchemea')
    {
	if ($session eq '')
	{
	    print "Warning: No session selected\n";
	    exit;
	}
	my @files = ();
	my $dir = '/home/elchemea/users/'.$user.'/'.$session.'/';
	if (-d $dir)
	{
	    opendir (MYDIR,$dir) or die "Could not open directory $dir $!\n";
	    @files = sort imp_sort grep {/\d\.i2b$/} readdir MYDIR;
	    closedir MYDIR;
	}
	print "OK\n";
	print join("\n",@files);
	exit;
    }
    if ($system && $system eq 'RFCcontrol')
    {
	if ($session eq '')
	{
	    print "Warning: No test selected\n";
	    exit;
	}
	my @files = ();
	my $dir = '/home/http/html/'.$user.'/'.$session.'/impedance/';
	if (-d $dir)
	{
	    opendir (MYDIR,$dir) or die "Could not open directory $dir $!\n";
	    @files = sort imp_sort grep {/\.i2b$/} readdir MYDIR;
	    closedir MYDIR;
	}
	print "OK\n";
	print join("\n",@files);
	exit;
    }
}


if ($ac eq 'plot')
{
    my $files = param('filenames');
    if ($files)
    {
	$files =~ /([\w\,\.\-\:\+\/\s]+)/;
	$files = $1;
    }
    my $sessionid = get_CGI_value_clean('session');
    my @list = split(/,/,$files);
    my $style = lc(param('style'));
    $style = 'lines' unless ($style);
    my $mode = param('mode');
    $mode = 'Impedance' unless ($mode);
    my $xmin = get_CGI_value_clean('xmin');
    my $xmax = get_CGI_value_clean('xmax');
    my $ymin = get_CGI_value_clean('ymin');
    my $ymax = get_CGI_value_clean('ymax');
    my $title = get_CGI_value_clean('title');
    my $admode = param('admode');
    $admode = 'Impedance' unless ($admode);
    $title = '' unless defined($title);
    my $scale = get_CGI_value_clean('scale');
    $scale = 0 unless ($scale);
    my %scalehash = (
		     -3 => 'm{/Symbol W}',
		     0 => '{/Symbol W}',
		     3 => 'k{/Symbol W}',
		     6 => 'M{/Symbol W}',
		     );
    my %scalefn = (
		     -3 => 'sf(x) = x * 1e3',
		     0 => 'sf(x) = x',
		     3 => 'sf(x) = x * 1e-3',
		     6 => 'sf(x) = x * 1e-6',		   
		   );
    foreach ($xmin,$xmax,$ymin,$ymax)
    {
	$_ = '' unless defined($_);
    }
    unless (@list)
    {
	print "Warning: No files selected for plotting";
	exit;
    }
    my @fl = ();
    my $user = get_CGI_value_clean('user');
    my $ses = get_CGI_value_clean('usersession');
    if ($user && defined($ses) && $ses =~ /\d/)
    {
	foreach my $item (@list)
	{
	    my ($file,$label) = split(/:/,$item);
	    $file =~ /\d+\_(.*)\.data/;
	    my $fn = $1;
	    my $dir = '';
	    my $system = param('system');
	    if ($system && $system eq 'Elchemea')
	    {
		$dir = '/home/elchemea/users/'.$user.'/'.$ses.'/';
	    }
	    if ($system && $system eq 'RFCcontrol')
	    {
		$dir = '/home/http/html/'.$user.'/'.$ses.'/impedance/';
	    }
	    my $f = SemaforeFile->new($dir.$fn);
	    my @l = $f->readlines();
	    my $o = SemaforeFile->new('/tmp/'.$file);
	    my $x = 0;
	    next unless (@l);
	    $x++ while ($l[$x] !~ /^[\s\t]*\d+[\s\t]*$/);
	    $x++;
	    my @reslines = ();
	    while ($x < @l)
	    {
		my $line = $l[$x++];
		my ($frq,$re,$im) = split(/[\s\t]+/,$line);
		next unless ($frq > 0); ## Skip 'zero lines'
		push @reslines,$line;
	    }
	    $o->writeline(@reslines);
	}
    }
    foreach my $item (@list)
    {
	my ($file,$label) = split(/:/,$item);
	push @fl, '/tmp/'.$file;
	$label =~ s/_/\\_/g;
	$item = $label;
    }
    my $pngfn = $pngdir.'multiplot_'.$$.'.png';
    my $psfn = $pngdir.'multiplot_'.$$.'.ps';
    my $gp = SemaforeFile->new('/tmp/multiplot_'.$$.'.gp');
    $gp->open_write;
    $gp->append('set zeroaxis lt -1');
    $gp->append("set out '$psfn'");
    my $color = lc(get_CGI_value_clean('color'));
    $color = 'color' unless $color;
    my $gsversion = `ghostscript -v`;
    if ($gsversion && $gsversion =~ /\s+([\d\.]+\s+)/)
    {
	$gsversion = $1;
    }
    else
    {
	$gsversion = 0;
    }
    if ($gsversion > 8.5)
    {
	$gp->append('set term postscript enhanced '.$color);
    }
    else
    {
	$gp->append('set term postscript enhanced portrait '.$color);
	$gp->append('set size 1,0.6');
    }
    my $key = lc(get_CGI_value_clean('key'));
    if ($key)
    {
	$key =~ s/^key\s//;
	$key .= ' reverse' if ($key =~ /left/);
	if ($key =~ /no key/i)
	{
	    $gp->append('set nokey');
	}
	else
	{
	    $gp->append('set key '.$key);
	}
    }
    my $x = 0;
    my $f = $fl[0];
    my $comm = param('comm');
    if ($comm && $comm =~ /([\w\s\n\r\t\.\[\]\-\+\,\"\'\.\:\(\)\^\=\/\*\{\}]+)/)
    {
	$comm = $1;
	$comm =~ s/[\r\n]+/\n/g;
    }
    else
    {
	$comm = '';
    }
    $gp->append("z(x) = x");
    $gp->append($scalefn{$scale});
    $gp->append("set title '$title'") if (length($title) > 0);
    if ($mode =~ /Bode/i)
    {
	my $ylabel = $scalehash{$scale};
	$gp->append("set xlabel 'Frequency (Hz)'");
	$gp->append('set logscale y');
	$gp->append('set logscale x');
	$gp->append('f(x) = x>0?x:-x');
	foreach ($xmin,$xmax,$ymin,$ymax)
	{
	    $_ = '' unless (defined($_) && $_ > 0);
	}
	$gp->append("set xrange [$xmin:$xmax]");
	$gp->append("set yrange [$ymin:$ymax]");
	$gp->append('set format x "10^{%L}"');
	$gp->append('set format y "10^{%L}"');
	my $lt = 0;
	my $pt = 0;
	my $str = undef;
	if ($admode eq "Admittance")
	{
	    $gp->append('G(x,y) = x/(x*x+y*y)');
	    $gp->append('B(x,y) = -y/(x*x+y*y)');
	    $ylabel =~ s/\{\/Symbol W\}/S/;
	    $gp->append("set ylabel 'Y (".$ylabel.")'");
	    $gp->append("\n",$comm,"\n");
	    if ($mode =~ /imag/)
	    {
		$str = "plot '$f' u 1:(z(sf(f(B(\$2,\$3))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0]'";
		for ($x = 1; $x < @fl; $x++)
		{
		    $str .= ", '$fl[$x]' u 1:(z(sf(f(B(\$2,\$3))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x]'";
		}			
	    }
	    else
	    {
		$str = "plot '$f' u 1:(z(sf(f(G(\$2,\$3))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0] Real','' u 1:(z(sf(f(B(\$2,\$3))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0] Imag'";
		for ($x = 1; $x < @fl; $x++)
		{
		    $str .= ", '$fl[$x]' u 1:(z(sf(f(G(\$2,\$3))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x] Real','' u 1:(z(sf(f(B(\$2,\$3))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x] Imag'";
		}
	    }
	}
	elsif ($admode eq "Complex modulus")
	{
	    $gp->append('Z(x,y) = {1,0} * x + {0,1} * y');
	    $gp->append('M(x) = {0,1} * 2 * pi * x');
	    $ylabel =~ s/\{\/Symbol W\}/\{\/Symbol W\}\/s/;
	    $gp->append("set ylabel 'M (".$ylabel.")'");
	    $gp->append("\n",$comm,"\n");
	    if ($mode =~ /imag/)
	    {
		$str = "plot '$f' u 1:(z(sf(f(imag(Z(\$2,\$3)*M(\$1)))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0]'";
		for ($x = 1; $x < @fl; $x++)
		{
		    $str .= ", '$fl[$x]' u 1:(z(sf(f(imag(Z(\$2,\$3)*M(\$1)))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x]'";
		}			
	    }
	    else
	    {
		$str = "plot '$f' u 1:(z(sf(f(real(Z(\$2,\$3)*M(\$1)))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0] Real','' u 1:(z(sf(f(imag(Z(\$2,\$3)*M(\$1)))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0] Imag'";
		for ($x = 1; $x < @fl; $x++)
		{
		    $str .= ", '$fl[$x]' u 1:(z(sf(f(real(Z(\$2,\$3)*M(\$1)))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x] Real','' u 1:(z(sf(f(imag(Z(\$2,\$3)*M(\$1)))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x] Imag'";
		}
		}
	}
	elsif ($admode eq "Complex capacitance")
	{
	    $gp->append('Z(x,y) = {1,0} * x + {0,1} * y');
	    $gp->append('M(x) = {0,1} * 2 * pi * x');
	    $ylabel =~ s/\{\/Symbol W\}/F/;
	    $gp->append("set ylabel 'C* (".$ylabel.")'");
	    $gp->append("\n",$comm,"\n");
	    if ($mode =~ /imag/)
	    {
		$str = "plot '$f' u 1:(z(sf(f(imag(1/(Z(\$2,\$3)*M(\$1))))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0]'";
		for ($x = 1; $x < @fl; $x++)
		{
		    $str .= ", '$fl[$x]' u 1:(z(sf(f(imag(1/(Z(\$2,\$3)*M(\$1))))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x]'";
		}			
	    }
	    else
	    {
		$str = "plot '$f' u 1:(z(sf(f(real(1/(Z(\$2,\$3)*M(\$1))))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0] Real','' u 1:(z(sf(f(imag(1/(Z(\$2,\$3)*M(\$1))))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0] Imag'";
		for ($x = 1; $x < @fl; $x++)
		{
		    $str .= ", '$fl[$x]' u 1:(z(sf(f(real(1/(Z(\$2,\$3)*M(\$1))))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x] Real','' u 1:(z(sf(f(imag(1/(Z(\$2,\$3)*M(\$1))))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x] Imag'";
		}
	    }
	}
	else
	{
	    $gp->append("set ylabel 'Z (".$ylabel.")'");
	    $gp->append("\n",$comm,"\n");
	    if ($mode =~ /imag/)
	    {
		$str = "plot '$f' u 1:(z(sf(f(\$3)))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0]'";
		for ($x = 1; $x < @fl; $x++)
		{
		    $str .= ", '$fl[$x]' u 1:(z(sf(f(\$3)))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x]'";
		}
	    }
	    else
	    {
		$str = "plot '$f' u 1:(z(sf(f(\$2)))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0] Real','' u 1:(z(sf(f(\$3)))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0] Imag'";
		for ($x = 1; $x < @fl; $x++)
		{
		    $str .= ", '$fl[$x]' u 1:(z(sf(f(\$2)))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x] Real','' u 1:(z(sf(f(\$3)))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x] Imag'";
		}
	    }
	}
	$gp->append($str);
    }
    else
    {
	$gp->append("set xrange [$xmin:$xmax]");
	$gp->append("set yrange [$ymin:$ymax]");
	$gp->append('set size ratio -1');
	my $xlabel = $scalehash{$scale};
	my $ylabel = $scalehash{$scale};
	if ($admode eq "Admittance")
	{
	    $xlabel =~ s/\{\/Symbol W\}/S/;
	    $ylabel =~ s/\{\/Symbol W\}/S/;
	    $gp->append("set ylabel 'Y_{imag} (".$ylabel.")'");
	    $gp->append("set xlabel 'Y_{real} (".$xlabel.")'");				
	}
	elsif ($admode eq "Complex modulus")
	{
	    $xlabel =~ s/\{\/Symbol W\}/\{\/Symbol W\}\/s/;
	    $ylabel =~ s/\{\/Symbol W\}/\{\/Symbol W\}\/s/;
	    $gp->append("set ylabel 'M_{imag} (".$ylabel.")'");
	    $gp->append("set xlabel 'M_{real} (".$xlabel.")'");				
	}
	elsif ($admode eq "Complex capacitance")
	{
	    $xlabel =~ s/\{\/Symbol W\}/F/;
	    $ylabel =~ s/\{\/Symbol W\}/F/;
	    $gp->append("set ylabel '-C*_{imag} (".$ylabel.")'");
	    $gp->append("set xlabel 'C*_{real} (".$xlabel.")'");				
	}
	else
	{
	    $gp->append("set ylabel '-Z_{imag} (".$ylabel.")'");
	    $gp->append("set xlabel 'Z_{real} (".$xlabel.")'");		
	}
	my $labels = get_CGI_value_clean('labels');
	if ($labels && $labels ne 'None')
	{
	    my $labelnr = 0;
	    if ($labels =~ /frequen/i )
	    {
		foreach my $file (@fl)
		{
		    my @frq = (0,0,0);
		    my @real = (0,0,0);
		    my @imag = (-1e100,-1e100,-1e100);
		    open MYIN,'<',$file or die "Could not open file $file for reading $!\n";
		    while (my $st = <MYIN>)
		    {
			next unless ($st && $st =~ /\d+/);
			my ($frq,$re,$im) = split(/[\s\t]+/,$st);
			next unless ($frq > 0);
			push @frq,$frq;
			if ($admode eq "Admittance")
			{
			    my $z = cplx($re,$im);
			    my $a = 1/$z;
			    push @real,Re($a);
			    push @imag,Im($a);
			}
			elsif ($admode eq "Complex modulus")
			{
			    my $z = cplx($re,$im);
			    my $a = $z*cplx(0,1)*2*pi*$frq;
			    $re = Re($a);
			    $im = -Im($a);
			}
			elsif ($admode eq "Complex capacitance")
			{
			    my $z = cplx($re,$im);
			    my $a = 1/($z*cplx(0,1)*2*pi*$frq);
			    $re = Re($a);
			    $im = Im($a);
			}
			else
			{
			    push @real,$re;
			    push @imag,-$im;
			}
		    }
		    push @frq,(0,0,0);
		    push @real,(0,0,0);
		    push @imag,(-1e100,-1e100,-1e100);
		    close MYIN;
		    for (my $x =  5; $x < @frq-6; $x++)
		    {
			my $left = &get_mean(@imag[$x-5..$x-2]);
			my $right = &get_mean(@imag[$x+2..$x+5]);
			my $center = &get_mean(@imag[$x-1..$x+1]);
			next unless ($center > $left && $center > $right);
			next unless ($imag[$x] > $imag[$x-1] && $imag[$x] > $imag[$x+1]);
			next if (($xmin =~ /\d/ && $real[$x]/10**$scale < $xmin) || ($xmax =~ /\d/ && $real[$x]/10**$scale > $xmax));
			next if (($ymin =~ /\d/ && $imag[$x]/10**$scale < $ymin) || ($ymax =~ /\d/ && $imag[$x]/10**$scale > $ymax));
			$gp->append('set label '.(++$labelnr).' "-- '.sprintf("%.3g",$frq[$x]).'" at z('.$real[$x]/10**$scale.'), z('.($imag[$x]/10**$scale).'), 0 left rotate');
		    }
		} 
	    } 
	    elsif ($labels =~ /decade/i)
	    {
		foreach my $file (@fl)
		{
		    my $fmax = undef;
		    open MYIN,'<',$file or die "Could not open file $file for reading $!\n";
		    while (my $st = <MYIN>)
		    {
			next unless ($st && $st =~ /\d+/);
			my ($frq,$re,$im) = split(/[\s\t]+/,$st);
			next unless ($frq > 0);
			$fmax = log($frq)/log(10) unless $fmax;
			next if (log($frq)/log(10) > ($fmax+0.01));
			$fmax--;
			if ($admode eq "Admittance")
			{
			    my $z = cplx($re,$im);
			    my $a = 1/$z;
			    $re = Re($a);
			    $im = -Im($a);
			}
			elsif ($admode eq "Complex modulus")
			{
			    my $z = cplx($re,$im);
			    my $a = $z*cplx(0,1)*2*pi*$frq;
			    $re = Re($a);
			    $im = -Im($a);
			}
			elsif ($admode eq "Complex capacitance")
			{
			    my $z = cplx($re,$im);
			    my $a = 1/($z*cplx(0,1)*2*pi*$frq);
			    $re = Re($a);
			    $im = Im($a);
			}
			else
			{ }
			next if (($xmin =~ /\d/ && $re/10**$scale < $xmin) || ($xmax =~ /\d/ && $re/10**$scale > $xmax));
			next if (($ymin =~ /\d/ && (-$im)/10**$scale < $ymin) || ($ymax =~ /\d/ && (-$im)/10**$scale > $ymax));
			$gp->append('set label '.(++$labelnr).' "-- '.sprintf("%.3g",$frq).'" at z('.$re/10**$scale.'), z('.(-$im/10**$scale).'), 0 left rotate');
		    }
		    close MYIN;
		}		
	    }
	    else
	    {
		foreach my $file (@fl)
		{
		    my $fmax = 0;
		    my $fmin = 1e100;
		    open MYIN,'<',$file or die "Could not open file $file for reading $!\n";
		    while (my $st = <MYIN>)
		    {
			next unless ($st && $st =~ /\d+/);
			my ($frq,$re,$im) = split(/[\s\t]+/,$st);
			next unless ($frq > 0);
			$fmax = $frq if ($frq > $fmax);
			$fmin = $frq if ($frq < $fmin);
		    }
		    close MYIN;
		    my $dist = (log($fmax)/log(10) - log($fmin)/log(10))/$labels;
		    $fmax = log($fmax)/log(10);
		    open MYIN,'<',$file or die "Could not open file $file for reading $!\n";
		    while (my $st = <MYIN>)
		    {
			next unless ($st && $st =~ /\d+/);
			my ($frq,$re,$im) = split(/[\s\t]+/,$st);
			next unless ($frq > 0);
			next if (log($frq)/log(10) > ($fmax+0.01*$dist));
			$fmax -= $dist;
			if ($admode eq "Admittance")
			{
			    my $z = cplx($re,$im);
			    my $a = 1/$z;
			    $re = Re($a);
			    $im = -Im($a);
			}
			elsif ($admode eq "Complex modulus")
			{
			    my $z = cplx($re,$im);
			    my $a = $z*cplx(0,1)*2*pi*$frq;
			    $re = Re($a);
			    $im = -Im($a);
			}
			elsif ($admode eq "Complex capacitance")
			{
			    my $z = cplx($re,$im);
			    my $a = 1/($z*cplx(0,1)*2*pi*$frq);
			    $re = Re($a);
			    $im = Im($a);
			}
			else
			{ }
			next if (($xmin =~ /\d/ && $re/10**$scale < $xmin) || ($xmax =~ /\d/ && $re/10**$scale > $xmax));
			next if (($ymin =~ /\d/ && (-$im)/10**$scale < $ymin) || ($ymax =~ /\d/ && (-$im)/10**$scale > $ymax));
			$gp->append('set label '.(++$labelnr).' "-- '.sprintf("%.3g",$frq).'" at z('.$re/10**$scale.'), z('.(-$im/10**$scale).'), 0 left rotate');
		    }
		    close MYIN;
		}		
	    }
	}
	my $lt = 0;
	my $pt = 0;
	$gp->append("\n",$comm,"\n");
	if ($admode eq "Admittance")
	{
	    $gp->append('G(x,y) = x/(x*x+y*y)');
	    $gp->append('B(x,y) = -y/(x*x+y*y)');
	    my $str = "plot '$f' u (z(sf(G(\$2,\$3)))):(z(sf(B(\$2,\$3)))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0]'";
	    for ($x = 1; $x < @fl; $x++)
	    {
		$str .= ", '$fl[$x]' u (z(sf(G(\$2,\$3)))):(z(sf(B(\$2,\$3)))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x]'";
	    }
	    $gp->append($str);
	}
	if ($admode eq "Complex modulus")
	{
	    $gp->append('Z(x,y) = {1,0} * x + {0,1} * y');
	    $gp->append('M(x) = {0,1} * 2 * pi * x');
	    my $str = "plot '$f' u (z(sf(real(Z(\$2,\$3)*M(\$1))))):(z(sf(imag(Z(\$2,\$3)*M(\$1))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0]'";
	    for ($x = 1; $x < @fl; $x++)
	    {
		$str .= ", '$fl[$x]' u (z(sf(real(Z(\$2,\$3)*M(\$1))))):(z(sf(imag(Z(\$2,\$3)*M(\$1))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x]'";
	    }
	    $gp->append($str);
	}
	if ($admode eq "Complex capacitance")
	{
	    $gp->append('Z(x,y) = {1,0} * x + {0,1} * y');
	    $gp->append('M(x) = {0,1} * 2 * pi * x');
	    my $str = "plot '$f' u (z(sf(real(1/(Z(\$2,\$3)*M(\$1)))))):(z(sf(-imag(1/(Z(\$2,\$3)*M(\$1)))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0]'";
	    for ($x = 1; $x < @fl; $x++)
	    {
		$str .= ", '$fl[$x]' u (z(sf(real(1/(Z(\$2,\$3)*M(\$1)))))):(z(sf(-imag(1/(Z(\$2,\$3)*M(\$1)))))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x]'";
	    }
	    $gp->append($str);
	}
	else
	{
	    my $str = "plot '$f' u (z(sf(\$2))):(z(sf(-\$3))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[0]'";
	    for ($x = 1; $x < @fl; $x++)
	    {
		$str .= ", '$fl[$x]' u (z(sf(\$2))):(z(sf(-\$3))) lt ".$lt[$lt++].' pt '.$pt[$pt++]." w $style tit '$list[$x]'";
	    }
	    $gp->append($str);	
	}
    }
    $gp->close;
    touch(@fl);
    eval {
	my $errfile = '/tmp/gp_error_'.$$;
        system('/usr/bin/gnuplot '.$gp->filename.' 2> '.$errfile);
	if (-e $errfile)
	{
	    open MYIN,'<',$errfile or die "Could not open file $errfile $!\n";
	    my @e = <MYIN>;
	    close MYIN;
	    unlink $errfile;
	    my $errstr = join("\n",@e);
	    die $errstr if ($errstr);
	}
	system('/usr/local/bin/analytic/ps2png '.$psfn.' '.$pngfn);
    };
    if ($@)
    {
        print "ERROR\n";
        print $@;
        unlink $gp->filename if ($gp->exist);
        exit;
    }
    print "OK\n";
    print 'multiplot_'.$$.'.png';
    unlink $gp->filename if ($gp->exist);
    ### Clean old files in pngdir ###
    my $dir = $Impedance::Header::htmldir.'/png/';
    opendir DIR,$dir or die "Could not open directory '$dir' $!\n";
    while (my $file = readdir(DIR))
    {
        next unless ($file =~ /\.png$|\.ps$/);
        my $fn = $dir.$file;
        my $sb = stat($fn);
        next unless ((time-300) > $sb->mtime);
        if ($fn =~ /([\w\.\/\-\,\:\(\)\[\]\s]+)/)
        {
            unlink $1 if -e ($1);
        }
    }
    ### Clean old data files in tmpdir (older than 1 hour) ###
    $dir = '/tmp/';
    opendir DIR,$dir or die "Could not open directory '$dir' $!\n";
    while (my $file = readdir(DIR))
    {
        next unless ($file =~ /\.data$|\.gp$|\.emp$/);
        my $fn = $dir.$file;
        my $sb = stat($fn);
        next unless ((time-3600) > $sb->mtime);
        if ($fn =~ /([\w\.\/\-\,\:\(\)\[\]\s]+)/)
        {
            unlink $1 if -e ($1);
        }
    }
    exit;
}


if ($ac eq 'save_file')
{
    my $name = get_CGI_value_clean('filename');
    my $data = param('data');
    my $sessionid = get_CGI_value_clean('session');
    unless ($name && $data && $sessionid)
    {
	print "Error: mangled data detected, file not saved!";
	exit;
    }
    my $path = '/tmp/';
    my $f = SemaforeFile->new($path.$sessionid.'_'.$name.'.data');
    $data =~s/\,/\t/g;
    $f->writeline($data);
    my $fn = $f->filename();
    if ($fn =~ /\/([\w\.\-\+]+)$/)
    {
	print "OK\n";
	print "$1\n";
	print $name,"\n";
    }
    else
    {
	print "Oops: Filename not valid: $fn";
	unlink $fn if -e $fn;
    }
    exit;
}



sub get_mean(@)
{
    my $n = 0;
    my $sum = 0;
    while (@_)
    {
	my $val = shift;
	next unless (defined($val));
	$sum += $val;
	$n++;
    }
    return $sum/$n if ($n);
    return 0;
}
