#!/usr/bin/perl -T
use strict;
use warnings;
use Impedance::Header;
use Impedance::Model;
use Impedance::IMPCGI qw(:html :cgi);
use CGI qw(:standard :netscape);
&print_header("Elchemea analytical",-onBlur=>'initiateSelfClosing()');
my $e = get_CGI_value_clean('type');
my $model = Impedance::Model->new();
my $m = Impedance::IMPCGI::format_model(param('model'));
$model->parse($m);
$model->data(param('data'));
my @data = split(/\n/,$model->data);
my @arr = ();
my $maxf = 0;
my $minf = 1e100;
my $x = 0;
foreach (@data)
{
    if (/([\d\.eE\+\-]+)/)
    {
	push @arr,"arr[$x] = $1;";
	$maxf = $1 if ($1 > $maxf);
	$minf = $1 if ($1 < $minf);
	$x++;
    }
}
my $arrstr = join("\n",@arr);
my $dummy = Impedance::Model->new();
$dummy->add_element('R');
my $id = $dummy->add_element($e);
my $mm = $dummy->print_model();
$mm =~ s/\n/\%0A/g;
$mm =~ s/\+/\%2B/g;
my $string = $id->helpfunction('R');
print center(h3($string));
my $m2 = Impedance::Model->new();
$m2->data($model->subtract_model);
my $data2 = $m2->data();
### Find min and max impedance ###
my $minr = $m2->minr() * 1.1;
my $maxr = $m2->maxr() * 1.1;
$minr = 0 if ($minr > 0);
$maxr = 0 if ($maxr < 0);
$data2 =~ s/\n/\%0A/g;
$data2 =~ s/\+/\%2B/g;
my $file = SemaforeFile->new('/tmp/model_'.$$.'.gp');
my $pngfn = $pngdir.'model_'.$$.'.png';
$file->writeline($Impedance::Header::gpheader);
$file->append("set out '$pngfn'");
$file->append("set title 'Residual data not yet accounted for by current model'");
my @l = $m2->print_plot;
my $dfile = SemaforeFile->new('/tmp/help_dat'.$$.'.dat');
my @d2 = split(/\n/,$m2->data());
$dfile->writeline($d2[0]);
$l[-1].= ", '".$dfile->filename."' u 2:(-\$3) w p tit 'min', '' u 2:(- \$3) w p tit 'sum/bend', '' u 2:(-\$3) w p tit 'max', '' u 2:(-\$3) w p tit 'F'";
$file->append(@l);
eval {
    system('/usr/bin/gnuplot '.$file->filename);
};
    if ($@)
{
    print h3({-class=>'Alert'},$@);
}


print '<center><img name="simulation" src="/analytic/png/model_'.$$.'.png" id="simulation"></center>';
unlink $file->filename if ($file->exist);
unlink $dfile->filename if ($dfile->exist);
print '<center><table border=0 cellspacing=10>';
print '<tr><td>';
print button(-name=>'l30',-value=>'<<x30',-class=>'s3',-onclick=>'set_f(f-30)');
print '</td><td>';
print button(-name=>'l10',-value=>'<<x10',-class=>'s3',-onclick=>'set_f(f-10)');
print '</td><td>';
print button(-name=>'l5',-value=>'<<x3',-class=>'s3',-onclick=>'set_f(f-3)');
print '</td><td>';
print button(-name=>'l',-value=>'<',-class=>'s3',-onclick=>'set_f(f-1)');
print '</td><td>';
print button(-name=>'ok',-value=>'Find values',-class=>'s0',-onclick=>'set_ok();');
print '</td><td>';
print button(-name=>'r',-value=>'>',-class=>'s3',-onclick=>'set_f(f+1)');
print '</td><td>';
print button(-name=>'r5',-value=>'>>x3',-class=>'s3',-onclick=>'set_f(f+3)');
print '</td><td>';
print button(-name=>'r10',-value=>'>>x10',-class=>'s3',-onclick=>'set_f(f+10)');
print '</td><td>';
print button(-name=>'r30',-value=>'>>x30',-class=>'s3',-onclick=>'set_f(f+30)');
print '</td></tr>';
print '<tr><td colspan=3>';
print button(-name=>'set_max',-value=>'Set maximum frequency',-class=>'s4',-onclick=>'maxf=f;set_f(f)');
print '</td><td colspan=3>';
print button(-name=>'set_sum',-value=>'Set summit/bend frequency',-class=>'s4',-onclick=>'sumf=f;set_f(f)');
print '</td><td colspan=3>';
print button(-name=>'set_min',-value=>'Set minimum frequency',-class=>'s4',-onclick=>'minf=f;set_f(f)');
print '</td></tr>';
print '<tr><td colspan=3></td><td colspan=3>';
print button(-id=>'action_btn',-name=>'test',-class=>'s5',-value=>'OK',-onclick=>'return_to_caller()');
print '</td></tr>';
print '<tr><th colspan=3>';
print 'X range (Zoom)';
print '</th><td colspan=3>';
print textfield(-name=>'minr',-value=>$minr,-force=>1,-class=>'textfield',-onchange=>'set_minr(this)');
print '</td><td colspan=3>';
print textfield(-name=>'maxr',-value=>$maxr,-force=>1,-class=>'textfield',-onchange=>'set_maxr(this)');
end_top_bar();
print '</center>';

print <<END;

<script language="javascript">

var gmaxr = $maxr;
var gminr = $minr;
var maxr = $maxr;
var minr = $minr;


var f = 0;
var maxf = 0;
var minf = 0;
var sumf = 0;
var m = '$mm';
var d = '$data2';

var arr = new Array;
$arrstr


function set_minr(e)
{
    var r = e.value
    if (r < gminr)
    {
	r = gminr;
	e.value = r;
    }
    minr = r;
    set_f(f);
}

function set_maxr(e)
{
    var r = e.value
    if (r > gmaxr)
    {
	r = gmaxr;
	e.value = r;
    }
    maxr = r;
    set_f(f);
}

function return_to_caller()
{
    opener.document.sofc.allow_close.value = 1;
    var btn =  opener.document.getElementById('action_btn');
    btn.focus();
    self.close();
}

function set_ok()
{
    var query = "&action=help_fit&min="+minf+"&sum="+sumf+"&max="+maxf+"&f="+f+"&model="+m+"&data="+d;
    query = query.replace(/\\n/g,"%0A");
    query = query.replace(/\\+/g,"%2B");
    run_ajax('ajax_model.cgi',query,set_fit);
}

function set_f(e)
{
    f = e;
    if (f < 0)
	f = 0;
    if (f >= arr.length)
	f = arr.length -1;
    var d = document.sofc.data.value;
    var m = document.sofc.model.value;
    var query = "&action=select_points&min="+minf+"&sum="+sumf+"&max="+maxf+"&f="+f+"&model="+m+"&data="+d+"&minr="+minr+"&maxr="+maxr;
    query = query.replace(/\\n/g,"%0A");
    query = query.replace(/\\+/g,"%2B");
    run_ajax('ajax_model.cgi',query,set_img);
}

function set_fit(res)
{
    var out = res.split("\\n");
    if (out[0] != "OK")
    {
        alert(res);
        return false;
    }
    var re = /INFO:/;
    var re2 = /R_1:/;
    x = 0;
    while (++x < out.length)
    {
	if (re2.test())
	    continue;
	if (re.test(out[x]))
	    break;
	var arr = out[x].split(/:/);
	var tag = arr[0].split(/_/);
	if (arr[0] == "R_1")
	    continue;
	var e = opener.document.getElementById('model_' + tag[0] );
	e.value = arr[1];
    }
    re = /FILE:/;
    while (++x < out.length)
    {
	if (!re.test(out[x]))
	    continue;
	var arr = out[x].split(/:/);
	var img = document.getElementById("simulation");
	img.src = arr[1] + "?" + Math.random();
	break;
    }
    var btn =  document.getElementById('action_btn');
    btn.focus();
}

function set_img(res)
{
    var out = res.split("\\n");
    if (out[0] != "OK")
    {
        alert(res);
        return false;
    }
    var img = document.getElementById("simulation");
    img.src = out[1] + "?" + Math.random();
}

</script>

END


    print end_html();
exit;

