#!/usr/bin/perl -T
use strict;
use warnings;
use Impedance::Model;
use Impedance::IMPCGI qw(:html :cgi);
use SemaforeFile;
use File::Copy;
use CGI qw(:standard :netscape);
if (param('action') && param('action') eq 'load')
{
    &print_header("Elchemea Analytical",-onload=>'set_data()');
    my @data = ();
    my $name = '';
    my $fdata = '';
    eval 
    {
	my $fn = Impedance::IMPCGI::file_upload('filename');
	die "No file returned from file_upload!" unless ($fn);
	my $f = SemaforeFile->new($fn);
	my @lines = $f->readlines();
	$fdata = join("\n",@lines);
	if ($fn && $fn =~ /\.z$/)
	{
	    my $newf = $fn;
	    $newf =~ s/\.z$/\.i2b/;
	    my $cmd = '/usr/local/bin/analytic/z_to_i2b '.$fn;
	    system($cmd);
	    move($newf,$fn);
	} 
	elsif ($fn && $fn =~ /\.i2b$/)
	{
	    # Do nothing #
	}
	else
	{
	    ### Assume gamry file ##
	    my $newf = $fn.'.i2b';
	    my $cmd = '/usr/local/bin/analytic/gamry_to_i2b.pl '.$fn;
	    system($cmd);
	    move($newf,$fn);
	}
	if ($fn)
	{
	    my @lines = $f->readlines();
	    my $x = 0;
	    while ($x++ < @lines)
	    {
		next unless (defined($lines[$x]) && $lines[$x] =~ /^[\s\t]*\d+[\s\t]*$/);
		last;
	    }
	    while ($x++ < @lines)
	    {
		push @data,$lines[$x] if (defined($lines[$x]) && $lines[$x] =~ /\d/);
	    }
	    if (defined($fn) && $fn =~ /([\w\d\-\.]+)$/)
	    {
		$name = $1;
	    }
	    unlink $f->filename if ($f->exist);
	}
    };
    my $data = join("\n",@data);
    print start_form(-name=>'sofc');
    print hidden(-name=>'data',-value=>$data,-force=>1);
    print hidden(-name=>'filedata',-value=>$fdata,-force=>1);
    print hidden(-name=>'filename',-value=>$name,-force=>1);
    print hidden(-name=>'allow_close',-value=>1,-force=>1);
    print end_form();

    print <<END;

<script language="javascript">

function set_data()
{
    opener.document.sofc.data.value = document.sofc.data.value;
    opener.document.sofc.filedata.value = document.sofc.filedata.value;
    opener.document.sofc.filename.value = document.sofc.filename.value;
    opener.document.sofc.mode.value = 'plot';
    opener.sofc_submit();
    self.close();
}

</script>

END
    
    print end_html();
exit;
}

#&print_header("Elchemea Analytical",-onBlur=>'initiateSelfClosing()');
&print_header("Elchemea Analytical");
print center(h1("Load Impedance file"));
print center(h3("File types accepted:"));
print center(h3("i2b files, Z-plot files, and Gamry files"));
print '<center><table border=0 cellspacing=20 width=100%><tr>';
print '<td width=70%>';
print start_form(-name=>'select');
print filefield(-name=>'filename',-class=>'textfield',-onchange=>'document.select.submit()');
print_hidden();
&action('load');
print end_form();
print '</td>';
end_top_bar();
print '</center>';
print end_html();
exit;

